///
/// @file   proto_io.h
/// @Author Adam Saxen
/// @date   Oktober, 2016
/// @brief  Auto generated Wrapper class for NanoPb library
///
/// This class is autogenerated based on the proto file
///

#ifndef PROTO_IO_H
#define PROTO_IO_H

#include <pb_encode.h>
#include <pb_decode.h>
#include "messages.pb.h"
#include <Arduino.h>


namespace ioant
{{
    //Base class IOAnt proto
    class ProtoIO
    {{

    public:
        struct MessageMeta
        {{
            uint8_t number_of_bytes;
            uint8_t message_type;
            bool valid;
            MessageMeta(uint8_t num_bytes, bool valid_msg, uint8_t msg_type){{
                number_of_bytes = num_bytes;
                valid = valid_msg;
                message_type = msg_type;
            }}
            MessageMeta(){{
                number_of_bytes = 0;
                valid = false;
                message_type = 0;
            }}
        }};
        ProtoIO(): send_buffer_(NULL), has_decoded_data_(false){{

        }};
        virtual ~ProtoIO(){{
            if (send_buffer_ != NULL)
                free(send_buffer_);
        }};
        static ProtoIO* CreateMessage(int message_type);
        virtual bool Decode(const uint8_t* buffer, unsigned int number_of_bytes) = 0;
        virtual bool Encode() = 0;

        MessageMeta GetMessageMeta(){{return messageMeta_;}};
        uint8_t* GetBufferHandle(){{return send_buffer_;}};
        enum MessageTypes{{{lookupmessagetypeenum}}};

    protected:
        bool has_decoded_data_;
        uint8_t* send_buffer_;
        MessageMeta messageMeta_;
    }};


    {messageClassesH}



}}


#endif
